﻿namespace UltraTreeScrollHorizontally
{
    using System;
    using System.Reflection;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinTree;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var nodes = this.AddNodes(this.ultraTree1.Nodes, 10);
            foreach (UltraTreeNode node in nodes)
            {
                this.AddNodes(node.Nodes, 3);
            }

            this.ultraTree1.Override.CellClickAction = CellClickAction.EditCell;
        }

        private TreeNodesCollection AddNodes(TreeNodesCollection nodes, int count)
        {
            for (int node = 0; node < count; node++)
            {
                nodes.Add(null, "Some long node name in order to appear scrolled ");
            }

            return nodes;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PropertyInfo scrollbarControlInfo = ultraTree1.GetType().GetProperty("ScrollbarControl", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetProperty);

            var scrollControl = scrollbarControlInfo.GetValue(this.ultraTree1, null);
            MethodInfo SetHScrollPositionMethod = scrollControl.GetType().GetMethod("SetHScrollPosition", BindingFlags.NonPublic | BindingFlags.Instance);

            SetHScrollPositionMethod.Invoke(scrollControl, new object[] { 20 });
        }
    }
}